#!/usr/bin/env python
# r3340 - an OSC IRC bot that want to take over the world
# DEPENDS: python-liblo, python-irclib

import liblo, sys
from ircbot import SingleServerIRCBot
from irclib import nm_to_n, nm_to_h, irc_lower, ip_numstr_to_quad, ip_quad_to_numstr

# send to OSC server <port> on localhost
# joins <channel> on <server>, as <nickname>
nickname = "dinosaur"
server = "irc.goto10.org"
channel = "#din"
ports = "7770"

try:
    targets = {}
    for port in ports.split(','):
        targets[port] = liblo.Address(port)

except liblo.AddressError, err:
    print str(err)
    sys.exit("oioioi osc address error")

# we are the robots
class TestBot(SingleServerIRCBot):
    def __init__(self, channel, nickname, server, port=6667):
        SingleServerIRCBot.__init__(self, [(server, port)], nickname, nickname)
        self.channel = channel

    def on_nicknameinuse(self, c, e):
        c.nick(c.get_nickname() + "_")

    def on_welcome(self, c, e):
        c.join(self.channel)
        print "I'm in #" + channel + "! :D"

    def on_pubmsg(self, c, e):
        a = e.arguments()[0].split(":", 1)
        if len(a) > 1 and irc_lower(a[0]) == irc_lower(self.connection.get_nickname()):
            self.do_command(e, a[1].strip())
        return

    def do_command(self, e, cmd):
        nick = nm_to_n(e.source())
        c = self.connection

        if cmd == "help":
            c.notice(self.channel, "feed me ASCII and I'll pass it to OSC port(s) " + ports)
        else:
            liblo.send (targets[port], cmd)

def main():
    bot = TestBot(channel, nickname, server, 6667)
    bot.start()

if __name__ == "__main__":
    main()
