/*
 * din irc bot
 *  
 * based on LGPLed code by Georgy Yunaev gyunaev@ulduzsoft.com 
 * of libircclient.sourceforge.net.
 * 
*/

#ifndef __BOT
#define __BOT

#include <libircclient/libircclient.h>
#include <cstring>
#include "command.h"

void* irc_monitor (void *pbot); 

// callbacks for various irc events
void dump_event (irc_session_t* session, const char* event, const char* origin, const char** params, unsigned int count);
void event_join (irc_session_t* session, const char* event, const char* origin, const char** params, unsigned int count);
void event_connect (irc_session_t* session, const char* event, const char* origin, const char** params, unsigned int count);
void event_privmsg (irc_session_t* session, const char* event, const char* origin, const char** params, unsigned int count);
void event_channel (irc_session_t* session, const char* event, const char* origin, const char** params, unsigned int count);
void irc_event_dcc_chat (irc_session_t* session, const char* nick, const char* addr, irc_dcc_t dccid);
void irc_event_dcc_send (irc_session_t* session, const char* nick, const char* addr, const char* filename, unsigned long size, irc_dcc_t dccid);
void event_numeric (irc_session_t* session, unsigned int event, const char* origin, const char** params, unsigned int count);

// utils
string get_nick (const char * origin);
struct tokenizer;

// the bot
//
struct bot : command {
	
	// libircclient
	irc_callbacks_t	callbacks;
	irc_session_t* sess;
	
	// server, nickname and channel
	string srv, nick, chan;
	
	string nickolon; // nick:
	int len;
	
	// message from irc
	string mesg;
	
	// irc monitoring thread
	pthread_t tid;
	
	int prefixed; // yes?
	string prefix; // eg., some_nick:
	
	bot (const string& ln, const string& sn, const string& hlp);
	~bot ();
	bool operator() (tokenizer& ss); // command parser
	
	int make ();
	int kill ();
	bot& operator<< (string& s);
	
};

#endif
