// string tokenizer
// based on code by Song Ho Ahn (song.ahn@gmail.com)

#ifndef TOKENIZER_H
#define TOKENIZER_H

#include <string>

const std::string DEFAULT_DELIMITER = " ";

struct tokenizer {
	tokenizer();
	tokenizer(const std::string& s, const std::string& d=DEFAULT_DELIMITER);

	tokenizer& operator>> (std::string& s);
	tokenizer& operator>> (float& f);
	tokenizer& operator>> (int& i);
	tokenizer& operator>> (char& c);

	std::string delimiter;
	std::string buffer;
	int blen, dlen;
	void str (const std::string& s);
	void set (const std::string& s, const std::string& d=DEFAULT_DELIMITER);
	void del (const std::string& d);
	bool isdelim (char c);
	void skip_ws ();

	int cur;
	void init_cur ();

	std::string token;
	
};

#endif 
