#include <algorithm>
#include <fstream>
#include <iostream>
#include "scalelist.h"
#include "console.h"
#include "tokenizer.h"
using namespace std;

extern console cons;

scalelist::scalelist () {
	load ();
}

scalelist::~scalelist () {
	save ();
}

void scalelist::add (tokenizer& tz) {
	string nam; tz >> nam;
	if (nam != "") {
		scale r;
		r.name = nam;
		string notes;
		while (1) {
			string s; tz >> s;
			if (s == "") break; else {
				notes = notes + s + " ";
				++r.num_notes;
			}
		}
		r.notes = notes;
		scales.push_back (r);
		cons << console::green << "added scale: " << nam << eol;
	}
}

void scalelist::ls () {
	for (int i = 0, j = scales.size(); i < j; ++i) {
		scale& r = scales[i];
		cons << console::yellow << ' ' << r.name << ' ' << r.notes << eol;
	}
}

void scalelist::remove (const string& nam) {
	scale r; r.name = nam;
	vector<scale>::iterator i = find (scales.begin(), scales.end(), r);
	if (i != scales.end()) {
		scales.erase (i); 
		cons << console::green << "removed scale: " << nam << eol;
	} else cons << console::red << "scale: " << nam << " not found." << eol;
}

void scalelist::load () {
	extern string dotdin;
	ifstream file ((dotdin + "scalelist").c_str(), ios::in);
	if (file) {
		int j;
		string ignore; file >> ignore >> j;
		for (int i = 0; i < j; ++i) {
			scale r;
			string nam; file >> nam; r.name = nam;
			file >> r.num_notes;
			for (int k = 0; k < r.num_notes; ++k) {
				string s; file >> s;
				r.notes = r.notes + s + ' ';
			}
			scales.push_back (r);
		}
	} else cout << "bad scalelist file" << endl;
}

void scalelist::save () {
	extern string dotdin;
	ofstream file ((dotdin + "scalelist").c_str(), ios::out);
	if (file) {
		int j = scales.size();
		file << "num_scales " << j << eol;
		for (int i = 0; i < j; ++i) {
			scale& r = scales[i];
			file << r.name << " " << r.num_notes << ' ' << r.notes << eol;
		}
	}
}

bool scalelist::get (const string& n, scale& r) {
	r.name = n;
	vector<scale>::iterator i = find (scales.begin(), scales.end(), r);
	if (i != scales.end()) {
		r = *i;
		return true;
	}
	return false;
}
